ISCacheMBean
Date: 2014-11-12

org.gcube.informationsystem.cache

## Interface ISCacheMBean

- All Known Implementing Classes:
    ISCache

      public interface ISCacheMBean

  Cache object. It provides cached information regarding the running instances of registered services. It exposes add/delete/enumerate operations on services as well as retrieval of corresponding running instances (URLs).
  Version:
    0.9
  Author:
    UoA

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `addFilterCriterion(Srv srv, java.lang.String srvType, java.lang.String critVar, java.lang.String critVal)` Add new filtering criterion on a specific service on a given type.
    `boolean` | `addFilterCriterion(java.lang.String srvClass, java.lang.String srvName, java.lang.String srvType, java.lang.String critVar, java.lang.String critVal)` Add new filtering criterion on a specific service on a given type.
    `boolean` | `delAllFilterCriterion(Srv srv, java.lang.String srvType)` Delete all filtering criteria from a specific service of a given type.
    `boolean` | `delAllFilterCriterion(java.lang.String srvClass, java.lang.String srvName, java.lang.String srvType)` Delete all filtering criteria from a specific service of a given type.
    `boolean` | `delFilterCriterion(Srv srv, java.lang.String srvType, java.lang.String critVar)` Delete filtering criterion from a specific service of a given type.
    `boolean` | `delFilterCriterion(java.lang.String srvClass, java.lang.String srvName, java.lang.String srvType, java.lang.String critVar)` Delete filtering criterion from a specific service of a given type.
    `java.lang.String[]` | `getAllFilterCriteria(Srv srv, java.lang.String srvType)` Get all filtering criteria from a specific service of a given type.
    `java.lang.String[]` | `getAllFilterCriteria(java.lang.String srvClass, java.lang.String srvName, java.lang.String srvType)` Get all filtering criteria from a specific service of a given type.
    `org.apache.axis.message.addressing.EndpointReference[]` | `getEPRsFor(Srv srv)` Get the running instances (array of URLs) of the specified service
    `org.apache.axis.message.addressing.EndpointReference[]` | `getEPRsFor(Srv srv, java.lang.String srvType)`
    `org.apache.axis.message.addressing.EndpointReference[]` | `getEPRsFor(java.lang.String srvClass, java.lang.String srvName)` Get the running instances (array of URLs) of the specified service
    `org.apache.axis.message.addressing.EndpointReference[]` | `getEPRsFor(java.lang.String srvClass, java.lang.String srvName, java.lang.String srvType)`
    `int` | `getSrvNumber()` Get number of registered services
    `java.lang.String[]` | `getSrvsStr()` Get registered services

- - ### Method Detail

    - #### getSrvsStr

          java.lang.String[] getSrvsStr()

      Get registered services
      Returns:
        the registered services

    - #### getSrvNumber

          int getSrvNumber()

      Get number of registered services
      Returns:
        the number of registered services

    - #### getEPRsFor

          org.apache.axis.message.addressing.EndpointReference[] getEPRsFor(java.lang.String srvClass,
                                                                          java.lang.String srvName)
                                                                            throws java.lang.Exception

      Get the running instances (array of URLs) of the specified service
      Parameters:
        `srvClass` - service class
        `srvName` - service name
      Returns:
        the running instances (array of URLs) of the specified service
      Throws:
        `java.lang.Exception` - in case of error; most probably due to the fact that the specified service is not registered.

    - #### getEPRsFor

          org.apache.axis.message.addressing.EndpointReference[] getEPRsFor(Srv srv)
                                                                            throws java.lang.Exception

      Get the running instances (array of URLs) of the specified service
      Parameters:
        `srv` - service
      Returns:
        the running instances (array of URLs) of the specified service
      Throws:
        `java.lang.Exception` - in case of error; most probably due to the fact that the specified service is not registered.

    - #### getEPRsFor

          org.apache.axis.message.addressing.EndpointReference[] getEPRsFor(Srv srv,
                                                                          java.lang.String srvType)
                                                                            throws java.lang.Exception

      Parameters:
        `srv` - service
        `srvType` - service type
      Returns:
        the running instances (array of EPRs) of the specified service
      Throws:
        `java.lang.Exception` - in case of error

    - #### getEPRsFor

          org.apache.axis.message.addressing.EndpointReference[] getEPRsFor(java.lang.String srvClass,
                                                                          java.lang.String srvName,
                                                                          java.lang.String srvType)
                                                                            throws java.lang.Exception

      Parameters:
        `srvClass` - service class
        `srvName` - service name
        `srvType` - service type
      Returns:
        the running instances (array of EPRs) of the specified service
      Throws:
        `java.lang.Exception` - in case of error

    - #### addFilterCriterion

          boolean addFilterCriterion(java.lang.String srvClass,
                                   java.lang.String srvName,
                                   java.lang.String srvType,
                                   java.lang.String critVar,
                                   java.lang.String critVal)
                                     throws java.lang.Exception

      Add new filtering criterion on a specific service on a given type. This filtering criterion applies only for the given service type.
      Parameters:
        `srvClass` - service class
        `srvName` - service name
        `srvType` - service type
        `critVar` - criterion r-value
        `critVal` - criterion l-value
      Returns:
        true if the critVar has not been added before; false otherwise
      Throws:
        `java.lang.Exception` - in case of error

    - #### addFilterCriterion

          boolean addFilterCriterion(Srv srv,
                                   java.lang.String srvType,
                                   java.lang.String critVar,
                                   java.lang.String critVal)
                                     throws java.lang.Exception

      Add new filtering criterion on a specific service on a given type. This filtering criterion applies only for the given service type.
      Parameters:
        `srv` - service instance
        `srvType` - service type
        `critVar` - criterion r-value
        `critVal` - criterion l-value
      Returns:
        true if the critVar has not been added before; false otherwise
      Throws:
        `java.lang.Exception` - in case of error

    - #### delFilterCriterion

          boolean delFilterCriterion(java.lang.String srvClass,
                                   java.lang.String srvName,
                                   java.lang.String srvType,
                                   java.lang.String critVar)
                                     throws java.lang.Exception

      Delete filtering criterion from a specific service of a given type.
      Parameters:
        `srvClass` - service class
        `srvName` - service name
        `srvType` - service type
        `critVar` - criterion r-value
      Returns:
        true if the critVar has been added; false otherwise
      Throws:
        `java.lang.Exception` - in case of error

    - #### delFilterCriterion

          boolean delFilterCriterion(Srv srv,
                                   java.lang.String srvType,
                                   java.lang.String critVar)
                                     throws java.lang.Exception

      Delete filtering criterion from a specific service of a given type.
      Parameters:
        `srv` - service instance
        `srvType` - service type
        `critVar` - criterion r-value
      Returns:
        true if the critVar has been added; false otherwise
      Throws:
        `java.lang.Exception` - in case of error

    - #### delAllFilterCriterion

          boolean delAllFilterCriterion(java.lang.String srvClass,
                                      java.lang.String srvName,
                                      java.lang.String srvType)
                                        throws java.lang.Exception

      Delete all filtering criteria from a specific service of a given type.
      Parameters:
        `srvClass` - service class
        `srvName` - service name
        `srvType` - service type
      Returns:
        true if the given service type already had some criteria; false otherwise
      Throws:
        `java.lang.Exception` - in case of error

    - #### delAllFilterCriterion

          boolean delAllFilterCriterion(Srv srv,
                                      java.lang.String srvType)
                                        throws java.lang.Exception

      Delete all filtering criteria from a specific service of a given type.
      Parameters:
        `srv` - service instance
        `srvType` - service type
      Returns:
        true if the given service type already had some criteria; false otherwise
      Throws:
        `java.lang.Exception` - in case of error

    - #### getAllFilterCriteria

          java.lang.String[] getAllFilterCriteria(java.lang.String srvClass,
                                                java.lang.String srvName,
                                                java.lang.String srvType)
                                                  throws java.lang.Exception

      Get all filtering criteria from a specific service of a given type.
      Parameters:
        `srvClass` - service class
        `srvName` - service name
        `srvType` - service type
      Returns:
        list of all criteria; key: criterion variable, value: criterion value
      Throws:
        `java.lang.Exception` - in case of error

    - #### getAllFilterCriteria

          java.lang.String[] getAllFilterCriteria(Srv srv,
                                                java.lang.String srvType)
                                                  throws java.lang.Exception

      Get all filtering criteria from a specific service of a given type.
      Parameters:
        `srv` - service instance
        `srvType` - service type
      Returns:
        list of all criteria; key: criterion variable, value: criterion value
      Throws:
        `java.lang.Exception` - in case of error